
-- Project: Blink
--
-- Blinks an LED.

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_MISC.all;
use IEEE.STD_LOGIC_UNSIGNED.all;
use IEEE.NUMERIC_STD.all;

entity blink is
  port 
   (
    clk       : in   std_logic;
    --
    blink_out : out  std_logic;
    -- unused LEDs
    led       : out  std_logic_vector(9 downto 1)
   );
end entity;

architecture Behavioral of blink is

   -- signal declarations
   signal cnt : unsigned(26 downto 0);
   
begin

   toggle_process : process(clk)
   begin
      if rising_edge(clk) then
         cnt <= cnt + 1;
      end if;
   end process;

   blink_out <= cnt(26);
   
end architecture Behavioral;

