
-- Project: Exercises, 7-segment, 4 displays
--

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_MISC.all;
use IEEE.STD_LOGIC_UNSIGNED.all;
use IEEE.NUMERIC_STD.all;

entity seven_segment is
  port 
   (
    clk          : in   std_logic;
    pb_1         : in   std_logic;
    pb_2         : in   std_logic;
    --
    seven_seg_1  : out  std_logic_vector(7 downto 0);
    seven_seg_2  : out  std_logic_vector(7 downto 0);
    seven_seg_3  : out  std_logic_vector(7 downto 0);
    seven_seg_4  : out  std_logic_vector(7 downto 0);
    en1          : out  std_logic;
    en2          : out  std_logic;
    en3          : out  std_logic;
    en4          : out  std_logic;
    -- unused LEDs
    led       : out  std_logic_vector(9 downto 0)
   );
end entity;

architecture Behavioral of seven_segment is

   -- component declarations
   
  component debounce is
  port 
   (
    clk          : in   std_logic;
    pb_in        : in   std_logic;
    --
    pb_debounced : out  std_logic
   );
   end component;

  component seg_control is
  port 
   (
    clk          : in   std_logic;
    pb_debncd_1  : in   std_logic;
    pb_debncd_2  : in   std_logic;
    --
    seven_seg_1  : out  std_logic_vector(7 downto 0);
    seven_seg_2  : out  std_logic_vector(7 downto 0);
    seven_seg_3  : out  std_logic_vector(7 downto 0);
    seven_seg_4  : out  std_logic_vector(7 downto 0);
    en1          : out  std_logic;
    en2          : out  std_logic;
    en3          : out  std_logic;
    en4          : out  std_logic
   );
   end component;

   -- signal declarations
   signal pb_debncd_1 : std_logic;
   signal pb_debncd_2 : std_logic;
   
begin

  debounce_1 : debounce
  port map
   (
    clk          => clk,         --in   std_logic;
    pb_in        => pb_1,        --in   std_logic;
    --
    pb_debounced => pb_debncd_1  --out  std_logic
   );

  debounce_2 : debounce
  port map
   (
    clk          => clk,         --in   std_logic;
    pb_in        => pb_2,        --in   std_logic;
    --
    pb_debounced => pb_debncd_2  --out  std_logic
   );

  seg_control_i : seg_control
  port map
   (
    clk          => clk,           --in   std_logic;
    pb_debncd_1  => pb_debncd_1,   --in   std_logic;
    pb_debncd_2  => pb_debncd_2,   --in   std_logic;
    --
    seven_seg_1  => seven_seg_1,   --out  std_logic_vector(7 downto 0);
    seven_seg_2  => seven_seg_2,   --out  std_logic_vector(7 downto 0);
    seven_seg_3  => seven_seg_3,   --out  std_logic_vector(7 downto 0);
    seven_seg_4  => seven_seg_4,   --out  std_logic_vector(7 downto 0);
    en1          => en1,           --out  std_logic;
    en2          => en2,           --out  std_logic;
    en3          => en3,           --out  std_logic;
    en4          => en4            --out  std_logic
   );
   
end architecture Behavioral;

