
-- Project: 7-segment
--
-- Debounces a switch contact.

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_MISC.all;
use IEEE.STD_LOGIC_UNSIGNED.all;
use IEEE.NUMERIC_STD.all;

entity debounce is
  port 
   (
    clk          : in   std_logic;
    pb_in        : in   std_logic;
    --
    pb_debounced : out  std_logic
   );
end entity;

architecture Behavioral of debounce is

   signal pb_in_d1 : std_logic;
   signal pb_in_d2 : std_logic;
   signal hold_cnt : unsigned(19 downto 0); -- ~10-20ms
   
begin

   debounce_process : process(clk)
   begin
      if rising_edge(clk) then
         pb_in_d1 <= pb_in;
         pb_in_d2 <= pb_in_d1;
         --
         if (pb_in_d2 /= pb_in_d1) then 
            hold_cnt <= X"00000";
         elsif (hold_cnt /= X"FFFFF") then
            hold_cnt <= hold_cnt + 1;
         end if;
         --
         if (hold_cnt = X"FFFFE") then
            pb_debounced <= pb_in_d1;
         end if;
      end if;
   end process;
   
end architecture Behavioral;

