
-- Project: Blink
--
-- Blinks an LED.

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_MISC.all;
use IEEE.STD_LOGIC_UNSIGNED.all;
use IEEE.NUMERIC_STD.all;

entity blink is
  port 
   (
    clk       : in   std_logic;
    --
    led_0     : out  std_logic;
    led_1     : out  std_logic;
    led_2     : out  std_logic;
    led_3     : out  std_logic;
    -- unused LEDs
    led       : out  std_logic_vector(9 downto 4)
   );
end entity;

architecture Behavioral of blink is

   -- signal declarations
   signal cnt : unsigned(26 downto 0);
   
begin

   toggle_process : process(clk)
   begin
      if rising_edge(clk) then
         cnt <= cnt + 1;
      end if;
   end process;

   led_0 <= cnt(26);
   led_1 <= cnt(25);
   led_2 <= cnt(26) AND cnt(25);
   led_3 <= cnt(26) AND cnt(25) AND cnt(24);
   
end architecture Behavioral;

