
-- Project: LED
--
-- Lights an LED on the board when a button is pushed.

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_MISC.all;

   entity led is
     port 
      (
       pb_in1    : in   std_logic;
       pb_in2    : in   std_logic;
       sw0       : in   std_logic;
       sw1       : in   std_logic;
       --
       led_out   : out  std_logic;
       led       : out  std_logic_vector(9 downto 1)
      );
   end entity;

architecture Behavioral of led is

   -- no declarations for this simple project.
   
begin

   
   led_out <= sw1 XOR (
                         (
                              (pb_in1 OR pb_in2)
                          AND (NOT sw0)
                         )
                       OR 
                         (
                              (pb_in1 AND pb_in2)
                          AND (sw0)
                         )
                      );

end architecture Behavioral;

