
-- Project: memories
--
-- Controls two external 7-segment displays.
--
-- !!!! this is for the Terasic board !!!!

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_MISC.all;
use IEEE.STD_LOGIC_UNSIGNED.all;
use IEEE.NUMERIC_STD.all;

entity seg_drive is
  port 
   (
    clk          : in   std_logic;
    mem_dat_1    : in   std_logic_vector(7 downto 0);
    mem_dat_2    : in   std_logic_vector(7 downto 0);
    --
    seven_seg_1  : out  std_logic_vector(7 downto 0);
    seven_seg_2  : out  std_logic_vector(7 downto 0);
    seven_seg_3  : out  std_logic_vector(7 downto 0);
    seven_seg_4  : out  std_logic_vector(7 downto 0);
    en1          : out  std_logic;
    en2          : out  std_logic;
    en3          : out  std_logic;
    en4          : out  std_logic 
   );
end entity;

architecture Behavioral of seg_drive is

  component seg_encode
  port 
   (
    hex_in     : in   std_logic_vector(3 downto 0);
    seven_seg  : out  std_logic_vector(7 downto 0)
   );
  end component;
   
begin

  en1 <= '0'; -- fixed active for Terasic
  en2 <= '0'; -- "
  en3 <= '0'; -- "
  en4 <= '0'; -- "

  seg_encode_1 : seg_encode
  port map
   (
    hex_in     => mem_dat_1(7 downto 4), 
    seven_seg  => seven_seg_1
   );

  seg_encode_2 : seg_encode
  port map
   (
    hex_in     => mem_dat_1(3 downto 0),
    seven_seg  => seven_seg_2
   );
   
  seg_encode_3 : seg_encode
  port map
   (
    hex_in     => mem_dat_2(7 downto 4),
    seven_seg  => seven_seg_3
   );
   
  seg_encode_4 : seg_encode
  port map
   (
    hex_in     => mem_dat_2(3 downto 0),
    seven_seg  => seven_seg_4
   );
   
end architecture Behavioral;

