
library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_MISC.all;
use IEEE.STD_LOGIC_UNSIGNED.all;
use IEEE.NUMERIC_STD.all;

  entity memory_8x8 is
  port
   (
    clk        : in  std_logic;
    dat_in     : in  std_logic_vector (7 downto 0);
    adr        : in  std_logic_vector (2 downto 0);
    wr         : in  std_logic;
    dat_out    : out std_logic_vector (7 downto 0)
   );
  end entity;

architecture Behavioral of memory_8x8 is

   type array_8x8 is array(0 to 7) of std_logic_vector(7 downto 0);
   signal mem : array_8x8;
   --
   signal adr_int : integer;

begin
   
   adr_int <= to_integer(unsigned(adr));

   main_proc : process(clk)
   begin
     if rising_edge(clk) then
       if (wr = '1') then
         mem(adr_int) <= dat_in;
       end if;
     end if;
     --
     dat_out <= mem(adr_int);
   end process;
   
end architecture Behavioral;

